/*
const xl4node = require("excel4node"); //importirame excel za node

const wb = new xl4node.Workbook();
const sheet = wb.addWorksheet("Sheet 1");
sheet.cell(1, 1).string("ID");
sheet.cell(2, 1).string("223-11a");
wb.write("test.xlsx");

import {promises} from "fs";

(async () => {
   const result = await promises.readFile("example.csv");
   const data = result.toString("utf-8");
   const rows = data.split("\n");
   const heading = rows[0].split(",");
   console.log({heading})
})();*/

const excel4node = require("excel4node");
import {promises} from "fs";

export class CsvToExcel {
    private readonly inputFileName: string;
    private readonly outputFileName: string;

    private workbook: any;
    private worksheet: any;

    constructor(inputFileName: string, outputFileName: string) {
        this.inputFileName = inputFileName + ".csv";
        this.outputFileName = outputFileName + ".xlsx";

        this.workbook = new excel4node.Workbook();
        this.worksheet = this.workbook.addWorksheet("User Data");
    }
    private async getFileData(inputFileName: string): Promise<string> {
        const buffer = await promises.readFile(inputFileName);
        return buffer.toString("utf-8");
    }

    private getHeading(fileData: string): string[] {
        let rows = fileData.split("\n");
        let firstRow = rows[0];
        return firstRow.split(",");
    }

    private getBody(fileData: string): string[][] {
        let rows = fileData.split("\n");
        rows.shift();
        return rows.map(row => row.split(","));
    }

    private generateExcel(headingRow: string[], bodyRows: string[][]): void {
        for (let index in headingRow) {
            this.worksheet.cell(1, parseInt(index) + 1)
                .string(headingRow[index]);
        }
        let row = 2;
        for (let index in bodyRows) {
            let cells = bodyRows[index];
            for (let cell in cells) {
                this.worksheet.cell(row, parseInt(cell) + 1)
                    .string(bodyRows[index][cell]);
            }
            row++;
        }
        this.workbook.write(this.outputFileName);
    }

    public async execute(): Promise<void> {
        const fileData = await this.getFileData(this.inputFileName);
        const headingRow = this.getHeading(fileData);
        const bodyRows = this.getBody(fileData);
        this.generateExcel(headingRow, bodyRows);
    }
}

const instance = new CsvToExcel("example", "product");
instance.execute();